uniform vec2 brushPos;
uniform vec2 brushDimensions;
uniform sampler2D brushTextureID;
uniform float brushIntensity;
uniform bool paintBrushMode;
varying vec3 normal;

void main(void)
{         
  
  vec4 txt = gl_TexCoord[1];
  txt /= gl_TexCoord[1].w;
	vec2 brush=vec2(brushDimensions.x , brushDimensions.y);       
  vec4 lowerLeft = vec4(brushPos,0.0,0.0) - vec4(brush,0.0,0.0);
  vec4 pos_in_brush_space = (txt - lowerLeft)/vec4(brush*2.0,0.0,0.0);
  if(normal.z < 0.0)
  {
    discard;
  }     
  if(txt.x > brushPos.x - brush.x && txt.x < brushPos.x + brush.x && txt.y > brushPos.y - brush.y && txt.y < brushPos.y + brush.y)
  { 
	  vec4 texColor = texture2DLod(brushTextureID,pos_in_brush_space.xy, 0.0);
	  float mx=1.0;
	  vec3 paintBrushColor;
	  if (paintBrushMode==false)	paintBrushColor=vec3(1.0,0.0,0.0);
	  else paintBrushColor=vec3(1.0,1.0,1.0);
    gl_FragColor.rgb = paintBrushColor.rgb;    
	  if (paintBrushMode==true) mx=4.0;
	  gl_FragColor.a = mx*brushIntensity*texColor.a; 
  }
  else discard; 
}
