varying vec3 vertex_light_position;
varying vec3 vertex_normal;
uniform float specularIntensity;
uniform sampler2D tex;
vec3 CoolColor = vec3(0.0, 0.0, 0.0);
float DiffuseCool = 0.35;
float DiffuseWarm = 0.45;
vec3 SurfaceColor = vec3(30.0/255.0,30.0/255.0,50.0/255.0);
vec3 WarmColor = vec3(70.0/255.0,70.0/255.0,70.0/255.0);
varying float NdotL;
varying vec3  ReflectVec;
varying vec3  ViewVec;

void main()
{
	vec3 kcool    = min(CoolColor + DiffuseCool * SurfaceColor, 1.0);
	vec3 kwarm = gl_Color.rgb;	// use the incoming fixed pipe color  
	vec3 kfinal   = mix(kcool, kwarm, NdotL);
  vec3 nreflect = normalize(ReflectVec);
	vec3 nview    = normalize(ViewVec);
	float spec    = max(dot(nreflect, nview), 0.0);
  spec          = 0.1 * pow(spec, 2.0);
	vec3 N = vertex_normal;
	vec3 L = normalize(gl_LightSource[0].position.xyz);
	vec3 H = normalize(gl_LightSource[0].halfVector.xyz);
	vec3 specularBlinn = vec3(1.0,1.0,1.0) * pow(max(dot(L, -N), 0.0), 16.0);
	float diffuse_value = max(dot(vertex_normal, vertex_light_position), 0.0);
	gl_FragColor = gl_Color * diffuse_value;
	gl_FragColor = gl_FragColor + vec4(min(kfinal+spec , 0.75) + 0.5*specularBlinn, 1.0);
	gl_FragColor = gl_Color;
	gl_FragColor.a = 1.0;
}